package md

type AdvertisingReq struct {
	Id   string `json:"id"`
	Ecpm string `json:"ecpm"`
}
type AdvertisingResp struct {
	Basic    AdvertisingBasic      `json:"basic" `
	Space    []AdvertisingSpace    `json:"space" `
	Function []AdvertisingFunction `json:"function" `
	Pop      AdvertisingLimit      `json:"pop" `
}
type AdvertisingBasic struct {
	Info                map[string]interface{} `json:"info" `
	AndroidAdIsOpen     string                 `json:"android_ad_is_open" example:"安卓广告是否开启(1:开启 0:不开启)"`
	IosAdIsOpen         string                 `json:"ios_ad_is_open" example:"ios广告是否开启(1:开启 0:不开启)"`
	AndroidOpenAdIsOpen string                 `json:"android_open_ad_is_open" example:"安卓开屏广告是否开启(1:开启 0:不开启)"`
	IosOpenAdIsOpen     string                 `json:"ios_open_ad_is_open" example:"ios开屏广告是否开启(1:开启 0:不开启)"`
	Voice               string                 `json:"voice" example:"领取声音"`
}
type AdvertisingSpace struct {
	Id           string                 `json:"id" example:"id"`
	Name         string                 `json:"name" example:"名称"`
	Kind         string                 `json:"kind" example:"广告类型(1:开屏广告 2:插屏广告 3:激励视频 4:信息流广告)"`
	Info         map[string]interface{} `json:"info" `
	CountingDown string                 `json:"counting_down" example:"倒计时 x秒"`
}
type AdvertisingCheck struct {
	IsCanVisit string `json:"is_can_visit"`
}
type AdvertisingState struct {
	IsSuccess string `json:"is_success"`
	Integral  string `json:"integral"`
}
type AdvertisingFunction struct {
	Name string `json:"name" example:"名称"`
	Type string `json:"type" example:"位置"`
	AdId string `json:"ad_id" example:"广告id"`
}
type AdvertisingLimit struct {
	PublicImg   string `json:"public_img" example:"公共弹窗图"`
	PublicStr   string `json:"public_str" example:"公共弹窗文字"`
	WithdrawImg string `json:"withdraw_img" example:"提现弹窗图"`
	WithdrawStr string `json:"withdraw_str" example:"提现弹窗文字"`
}
